function [t,tek] = coltime(optim_param,lim)
% COLTIME - returns values representing times in collocation points over
% full interval [t0,tf] and values representing times in element knots.

% This function is used in initoptimvar, cmconfun, cmconfungrad, cmobjfun
% and cmobjfungrad functions.


% first element knot is zeta_0 = 0, next are zeta_i = sum(tek_pom(1:i))
tek_temp = [0;lim];
tek = cumsum(tek_temp); 

% ncol+2-by-ni matrix t over all time interval [t0,tf]
t = optim_param.tau*lim' + ones(length(optim_param.tau),1)*tek(1:end-1)'; 
%--------------------------------------------------------------------------