function [dtdli,dtekdli] = dercoltime(optim_param,i)
% DERCOLTIME - returns the derivative of time in collocation points and the
% derivative of time in the element knots with respect to the lengths of
% intervals for a given element/interval.

% This function is used in cmconfungrad, cmobjfungrad functions.


% derivative of lengths of intervals with respect to themselves
% ni-by-ni matrix
dli_temp = [zeros(optim_param.ni,1) eye(optim_param.ni)]';
dli = cumsum(dli_temp);

% derivative of time in interval i with respect to the lengths of intervals
% ni-by-ncolx+2 matrix dt/dli over all time interval [zeta_i-1,zeta_i]
dt_temp = eye(optim_param.ni);
dtdli = (optim_param.tau*dt_temp(i,:) + ones(length(optim_param.tau),1)*dli(i,:))';

if nargout == 2 
    dtekdli = dtdli(:,end);
end
%--------------------------------------------------------------------------